'Piotr Krzyaniak
'silnik prawy p1.7,  p1.6
'silnik lewy p1.5, p1.4
'zezwolenie na nadawanie IR p1.3
'odbiorniki IR na przerwaniach INT0 INT1
'uklad wspolpracujacy z ukladem MC145027
'*********************
'* odbiornik 433 MHz *
'*********************
Dim Dana As Byte
On Int0 Zakrecamy1
On Int1 Zakrecamy2
Enable Int0
Enable Int1
Reset P1.7
Reset P1.6
Reset P1.5
Reset P1.4
Reset P1.3
Dana = 0

Do
Call Odbierz
Call Sprawdz
Waitms 200

Loop

Sub Sprawdz
 If Dana < 10 Then
  Call Accumulator
 End If
 If Dana => 10 Then
  If Dana = 10 Then
   Call Zakoncz
  End If
  If Dana = 11 Then
   Call Zacznij
  End If
 End If
End Sub

Sub Accumulator
Acc = Dana
If Acc.0 = 1 Then
 Set P1.7
End If
If Acc.0 = 0 Then
 Reset P1.7
End If
If Acc.1 = 1 Then
 Set P1.6
End If
If Acc.1 = 0 Then
 Reset P1.6
End If
If Acc.2 = 1 Then
 Set P1.5
End If
If Acc.2 = 0 Then
 Reset P1.5
End If
If Acc.3 = 1 Then
 Set P1.4
End If
If Acc.3 = 0 Then
 Reset P1.4
End If
Waitms 500
End Sub

Sub Zakoncz
 Disable Interrupts
 Reset P1.3
End Sub

Sub Zacznij
 Enable Interrupts
 Set P1.3
 Do
 Call Odbierz
  If Dana <> 10 Then
   Set P1.7
   Reset P1.6
   Set P1.5
   Reset P1.4
   Waitms 300
  End If
 Loop Until Dana = 10
End Sub

Sub Odbierz
  If P3.0 = 0 Then
   Acc.3 = 0
  End If
  If P3.0 = 1 Then
   Acc.3 = 1
  End If
  If P3.1 = 0 Then
   Acc.2 = 0
  End If
  If P3.1 = 1 Then
   Acc.2 = 1
  End If
  If P3.4 = 0 Then
   Acc.0 = 0
  End If
  If P3.4 = 1 Then
   Acc.0 = 1
  End If
  If P3.5 = 0 Then
   Acc.1 = 0
  End If
  If P3.5 = 1 Then
   Acc.1 = 1
  End If
  Dana = Acc
End Sub


Zakrecamy1:
 Set P1.7
 Reset P1.6
 Reset P1.5
 Set P1.4
 Wait 2
Return

Zakrecamy2:
 Reset P1.7
 Set P1.6
 Set P1.5
 Reset P1.4
 Wait 2
Return